=============
Version 1.0.2
=============

* RetroCoreDescriptor: Propagate an accidentally unhandled error.
* Implement mouse buttons 4 and 5.
* Fix the GLES context initialization.
* Drop the code making temporary copies of the core to avoid static
  variable collisions, this isn't needed anymore as such collisions
  can't happen since a single instance of a core is used per subprocess.
* Debug:
 - Catch SIGSEGV, SIGABRT or any crash on the runner and print a
   backtrace when the RETRO_DEBUG environement variable is set to 1.
 - Print more debug info o successful Libretro environement commands
   when the RETRO_DEBUG environement variable is set to 1.
* Libretro environment commands:
 - Set the log domain to RetroEnvironment.
 - Fix ABI issues by corretly using bool instead of gboolean for command
   parameters.
 - Prevent setting unknown pixel formats and rotations.
 - Better log hardware rendering context support errors.
 - Log a critical error when getting a variable failed.
 - Log a critical error when receiving un unknown and unimplemented
   commands.
* Generalize usage of auto cleanups.
* Many code style cleanups.

=============
Version 1.0.1
=============

* RetroCoreView: Add the key press, key release and touch event masks
  to ensure it receives all the events it can handle, and hence to
  ensure that these input methods work as expected.
* Meson: Add the vapi option to allow disabling building Vala bindings.
* Documentation:
 - Add the Libretro Core Descriptor Specification 1.0 section.
 - Add the Retro Reference Test Case Specification 1.0 section.
* Clean up the documentation, README.md, HACKING.md, retro-gtk.doap,
  .editorconfig, update-from-retroarch, the Meson files, and more.

=============
Version 1.0.0
=============

* Major API overhaul and API version bump, detailing all the changes
  would be ridiculous and hence won't be done.
* Run Libretro cores isolated in a dedicated subprocess, similarly to
  how modern web browsers handle web pages.
* Support Libretro cores rendering their video with OpenGL.
* Improve the Libretro core timing accuracy.
* Resample the Libretro core's audio output to ensure it matches its
  play speed.
* Publish the nightly reference manual at
  https://gnome.pages.gitlab.gnome.org/retro-gtk/.

==============
Version 0.18.1
==============

* Meson:
 - Bump the required version to 0.50.0 to fix a build-time-warning.
 - Explicitly specify the GIR namespace and the packages GIR exports.
* RetroGLDisplay:
 - Scale coordinates on display for pointer inputs to work in Hi-DPI.
* Register a GType for RetroRumbleEffect.

==============
Version 0.18.0
==============

* Pixbufs:
 - Add retro_pixbuf_set_aspect_ratio() for embedding aspect ratio
   value to a GdkPixbuf.
 - Add retro_pixbuf_get_aspect_ratio() for retrieving the value
   set with retro_pixbuf_set_aspect_ratio().
 - Deprecate x-dpi and y-dpi metadata options.
* RetroCoreView:
 - Take pixbuf aspect ratio into account when drawing a standalone
   pixbuf instead of using aspect ratio of the current core.
* Fix build on Fedora 30.

==============
Version 0.16.1
==============

* RetroCoreView:
 - Support RETRO_CONTROLLER_TYPE_KEYBOARD.
* RetroCore:
 - Bufferize single audio frames to emit them as batches for better
   performances.
* Add CSS names to widgets.

==============
Version 0.16.0
==============

* Update README.md.

===============
Version 0.15.90
===============

* RetroMainLoop:
 - Lower the priority of the loop to prevent a lagging game from
   freezing the rendering of its video.
 - Prevent reference leaking when destroying the loop while its not
   stopped by not giving a reference to the loop's callback.
* RetroGLDisplay:
 - Take the UI's scale into account, making it usable in Hi-DPI.
* Prepare RetroGLDisplay for GTK+ 4:
 - Don't clear depth buffer as we don't use it and as this would cause
   glitches in GTK+ 4.
 - Explicitly use glClearColor().
 - Call glBindTexture() on every frame to ensure that we're always
   working with the right texture, which is needed for GTK+ 4.
* Fix reference cycles in retro-demo to avoid memory leaks.

==============
Version 0.15.3
==============

* Add the RetroOption, RetroOptionIterator and RetroKeyJoypadMapping
  types to the public API.
* RetroCore:
 - Add the 'runahead' property. This allow the core to output the video
   and audio of a future frame, allowing to compensate for input lag
   from the original hardware for console emulator cores.
 - Add the retro_core_has_option(), retro_core_get_option() and
   retro_core_iterate_options() option accessors.
 - Add the 'options-set' signal. The signal is emitted when the core
   initially sets the options during boot. This allows setting options
   that require being set before the core is initialized.
* RetroCoreView:
 - Use a RetroKeyJoypadMapping to let users set its keyboard to virtual
   joypad mapping.
 - Set default controllers only for actually supported capabilities.
* Make RetroCoreViewController return only the capability matching its
  type and not all the the capabilities of its RetroCoreView.
* Add retro_joypad_id_to_button_code() and
  retro_joypad_id_from_button_code() to convert a Linux button event
  code into a RetroJoypadId and vice versa.
* Add RETRO_RUMBLE_EFFECT_COUNT, allowing to know the number of values
  of RetrormbleEffect.
* Libretro environment commands:
 - Implement RETRO_ENVIRONMENT_SET_GEOMETRY, allowing cores to change
   the aspect ratio separately from the framerate.
 - Implement RETRO_ENVIRONMENT_GET_LANGUAGE, allowing cores to know the
   user's language.
 - Fix a missing return in the implementation of
   RETRO_ENVIRONMENT_SET_DISK_CONTROL_INTERFACE, which could have led
   the cores to think we don't support it.
* Fix various runtime warnings and potential crashes.
* Improve internal documentation on keyboard key convertion.
* Add UNIMPLEMENTED.md as documentation of what is unimplemented from
  the Libretro API, updated to retroarch 1.7.2.
* Add the retro-reftest program allowing to easily run reference tests
  on Libretro cores, based on retro-gtk and test descriptor files.
 - It allows to generate the test references via the --generate option.
 - It allows to control the core by setting controllers and their
   inputs.
 - It can check that a core boots.
 - It can check that it has the expected options.
 - It can check that its internal state can or can't be accessed.
 - It can check that a frame runs.
 - It can check that the video output is as expected
* Add the retro-dummy dummy Libretro core, used to run unit tests and
  reference tests.
* Add some RetroCore unit tests.
* Let retro-demo take parameters for medias to load into the core.
* Add the following options to Meson:
 - 'introspection' to disable compilation of instrospection.
 - 'demos' to disable compilation of demos.
 - 'build-tests' to disable compilation of tests.
 - 'install-tests' to enable installation of tests.

==============
Version 0.14.0
==============

* Add dependency on libepoxy.
* RetroCoreView:
 - Render the video with OpenGL instead of Cairo.
 - Drop the 'pixbuf' property, bt keep the pixbuf accessor functions.
   This avoids an automatic and probably useless convertion of the video
   to a GdkPixbuf as it isn't part of the rendering pipeline anymore.
 - Grab the focus when clicked, avoiding to miss the player's keyboard
   events to control the game.
 - Allow it to be the default widget by default bt setting the
   'can-default' property to TRUE on construction.
* Add internal support for GLSL based video filters and port the
  existing ones to GLSL so they can work with the OpenGL renderer.
* Add RETRO_VIDEO_FILTER_CRT, a RetroVideoFilter demanding the video
  display to mimick a CRT TV screen.
* RetroPixdata:
 - Add retro_pixdata_get_width/height() and
   retro_pixdata_load_gl_texture(), allowing to export the pixel data to
   an OpenGL texture and to draw it at the expected size.
 - Don't fail when constructing with a non-zero rowstride, as these are
   valid values.
* Add the set_rumble_state() virtual method to RetroController and
  implement it in RetroCoreViewController.
* Build system change: make retro-gtk-demo properly depend on retro-gtk.
* The project moved to https://gitlab.gnome.org/GNOME/retro-gtk.

* Bugs fixed:
 - https://bugzilla.gnome.org/show_bug.cgi?id=790454

==============
Version 0.13.2
==============

* Port the build system to Meson, requiring version 0.43.0 and drop the
  Autotools.
* Drop retro_core_remove_controller(), to remove a controller instead
  set it to NULL.
* Make retro_core_poll_controllers(),
  retro_core_get_controller_input_state() and
  retro_core_get_controller_capabilities() private as they are meant to
  be used by the Libretro core and not the end users.
* Add retro_core_set_default_controller() to set controllers to be used
  by default when there is no controller with the requested capability
  in the requested port. Add retro_core_view_set_as_default_controller()
  to easily set the controllers of a RetroCoreView as the default
  controllers of a RetroCore. retro-demo now uses these.
* Add retro_controller_has_capability() to easily check if a controller
  has the given RetroControllerType capability.
* Add RetroInput to encapsulate the inputs used in an input state query.
  It is used in retro_controller_get_input_state() and
  retro_core_view_get_input_state().
* Replace gboolean by bool in get_variable_update() to avoid crashes.
* Add a count enumeration value to RetroControllerType and the various
  controller code enumerations.
* Better check the creation of the PuleAudio sound output to avoid
  crashes.

==============
Version 0.13.1
==============

This version ports retro-gtk from Vala to C and simnplifies the API a
lot. It comes with lots of API breaks, so many that it would be simpler
to list what remained similar to the 0.12 branch than what changed.

The API will keep changing during the 0.14 development cycle, but it is
hoped to lead to less API breaks after that.

Reviewers: given how much changed, consider this as a new librarby,
don't review it in comparison with its previous versions.

* Bugs fixed:
 782501 retro-gtk: Port to C
 787548 mGBA fails to save memory
 787769 retro-gtk: Keyboard keys can be stuck
 788826 Can't find libretro cores with firmwares


==============
Version 0.12.0
==============

* Core: avoid a double free when loading multiple discs.

* CoreViewInputDevice: don't throw errors when the view is NULL.

* Bugs fixed:
 787492 retro-gtk: SIGABRT in retro_game_info_free


===============
Version 0.11.92
===============

* Core:
 - Remove the barely used system-info property.
 - Use Gdk.EventKey for keyboard inputs.
 - Make the init singal an error-throwing method.
 - Implement disk handling directly.

* CoreView can be exposed as a joypad, a mouse or a pointer.

* retro-demo:
 - Add pointer support from CoreView.

* Make all error domains internal.

* Make internal and port to C:
 - GameInfo.
 - Module.
 - SystemAvInfo.
 - SystemInfo.
 - most of Core.
 - keyboard keys.

* Remove unused symbols:
 - DiskControl.
 - GamepadConfiguration.
 - GamepadButtonType.
 - Keyboard.
 - KeyboardState.
 - MemDesc.
 - MemoryDescriptor.
 - MemoryMap.
 - Mouse.
 - VirtualGamepad.
 - get_system_info ().
 - SNES specific memory types from MemoryType.

* Bugs fixed:
 777489 Refactor the whole API


================
Version 0.11.4.1
================

* Distribute retro-core.h and retro-rotation.h.


==============
Version 0.11.4
==============

* A demo application has been added, it allows to directly test the
  without the need of an external tool.

* Loading games:
 - Add the set_medias(), load_medias() and set_current_media() methods
   to Core and load the given medias (if any) in Core.init().
 - Remove load_game() and prepare() Core methods from the public API as
   they are now used indirectly.
 - This should simplify loading games for the users of the library.

* Logging:
 - Add the Core.log() signal which will emit a GLib compatible logging
   message with the Libretro core's name as the log domain.
 - Add retro_g_log() to simply handle Core.log() by outputing the logs
   in the expected unstructured GLib fashion.
 - Remove LogLevel, Log and FileStreamLog as they are now useless.

* Add CoreView as a prototype of a single widget to handle most inputs
  and outputs of a core and use it in the demo.

* Add CoreDescriptor.get_uri().

* Make CairoDisplay.set_core() and Make PaPlayer.set_core() accept null.

* Fix the transmission of keyboard events to the Libretro core.

* Rotation and many methods of Core are ported to C.

* Bugs fixed:
 777489 Refactor the whole API
 780919 Add a demo application
 782501 retro-gtk: Port to C
 782504 retro-gtk: Improve Libretro core logging
 782505 retro-gtk: (on_input_state): should not be reached
 782772 retro: Libretro cores should have an appropriate save directory

==============
Version 0.10.0
==============

* Save the expected ratio as DPI of the video frames

* Bugs fixed:
 769833 Add metadata to screenshots
 779924 gnome-games crash with SIGSEGV in retro_core_set_callbacks()
 779987 release tarballs don't have generated files


==============
Version 0.9.92
==============

* Allow recursive iteration through Libretro cores of a directory


==============
Version 0.9.91
==============

* Ongoing refactoring:
 - Deduplicate documentation
 - Add missing MouseId values
 - Remove deprecated input device types

* Libretro module query:
 - Allow to check the firmwares
 - Add an helper method to chek the supported MIME types
 - Add a module iterator, allowing sync and async browsing
 - Remove the now useless foreach function

* Core:
 - Add methods to handle standalone cores more easily

* Fix an integer division when computing the aspect ratio

* Add a script to update libretro.h

* Bugs fixed:
 777371 Support standalone Libretro games
 777987 Allow to have a sharp video output
 778744 Check required firmwares are present


==============
Version 0.9.90
==============

* Ongoing refactoring:
 - Merge the retro-gobject module into retro-gtk
 - Merge the RetroGtk namespace into Retro
 - Remove many unused types and functions
 - Refactor many types and functions
 - Make the API overall simpler

* Libretro module query:
 - Search modules from their Libretro Core Descriptor
 - Search Libretro modules in paths from the LIBRETRO_PLUGIN_PATH env variable
 - Drop the ancient module query mechanisms
 - Drop the ancient Libretro core path env variable

* Allow to set a smooth or sharp rendering to CairoDisplay

* Bugs fixed:
 777482: retro-gobject: Remove unused private code
 777987: Allow to have a sharp video output
 778446: Support the Libretro Core Descriptor format


=============
Version 0.8.1
=============

* Fix module lookup failing early when a directory doesn't exist

* Bugs fixed:
 771624 retro-gobject: Libretro module query fail when directory doesn't exist


===========
Version 0.8
===========

* Merge retro-gobject into the retro-gtk tree

* Remove deprecated symbols:
 - Retro.CoreFactory
 - Retro.get_plugins_dir()
 - Retro.search_module()
 - Retro.PROJECT_PLUGINS_DIR
 - RetroGtk.ClutterDisplay
 - RetroGtk.init()

* Add dependency on libpulse-simple

* Remove dependency on clutter-gtk

* Add unstable API guards

* Clean up multiple parts of the code and the build system

* Allow to look for modules by the content of their .info file

* Make the Retro.Rumble interface public

* Fix the speed at which games are run

* Fix sound stopping to play after some time

* Bugs fixed:
 769306 retro-gobject: Fix typo
 769317 retro-gobject: Make Rumble public
 769415 Wrong location for retro-gtk.h and retro-gobject.h
 769729 retro-gobject: Allow to search modules from their .info
 769880 retro-gobject: Refactor retro-environment* files
 770340 Sound stops after some minutes


===========
Version 0.6
===========

* Remove dependency to JSK


===========
Version 0.4
===========

* Deprecate ClutterDisplay and RetroGtk.init().

* Use kebab-case file naming convention.

* CairoDisplay
 - Draw on a publicly available Gdk.Pixbuf.
 - Render itself desaturated when insensitive.

* PaDevice
 - Stop playing when destroyed to prevents crashes.
